package model

import "github.com/shopspring/decimal"

type EndUserDetail struct {
	CreatedAndModified       `xorm:"extends"`
	ReportId                 string              `xorm:"varchar(120) pk not null" json:"reportId"`
	ParkId                   string              `xorm:"varchar(120) pk not null" json:"parkId"`
	MeterId                  string              `xorm:"meter_04kv_id varchar(120) pk not null" json:"meterId"`
	Seq                      int64               `xorm:"bigint not null default 0" json:"seq"`
	Ratio                    decimal.Decimal     `xorm:"numeric(8,4) not null default 1" json:"ratio"`
	Address                  *string             `xorm:"varchar(100)" json:"address"`
	CustomerName             *string             `xorm:"varchar(100)" json:"customerName"`
	ContactName              *string             `xorm:"varchar(70)" json:"contactName"`
	ContactPhone             *string             `xorm:"varchar(50)" json:"contactPhone"`
	IsPublicMeter            bool                `xorm:"'public_meter' bool not null default false" json:"isPublicMeter"`
	WillDilute               bool                `xorm:"'dilute' bool not null default false" json:"willDilute"`
	LastPeriodOverall        decimal.Decimal     `xorm:"numeric(14,2) not null default 0" json:"lastPeriodOverall"`
	LastPeriodCritical       decimal.Decimal     `xorm:"numeric(14,2) not null default 0" json:"lastPeriodCritical"`
	LastPeriodPeek           decimal.Decimal     `xorm:"numeric(14,2) not null default 0" json:"lastPeriodPeek"`
	LastPeriodFlat           decimal.Decimal     `xorm:"numeric(14,2) not null default 0" json:"lastPeriodFlat"`
	LastPeriodValley         decimal.Decimal     `xorm:"numeric(14,2) not null default 0" json:"lastPeriodValley"`
	CurrentPeriodOverall     decimal.Decimal     `xorm:"numeric(14,2) not null default 0" json:"currentPeriodOverall"`
	CurrentPeriodCritical    decimal.Decimal     `xorm:"numeric(14,2) not null default 0" json:"currentPeriodCritical"`
	CurrentPeriodPeek        decimal.Decimal     `xorm:"numeric(14,2) not null default 0" json:"currentPeriodPeek"`
	CurrentPeriodFlat        decimal.Decimal     `xorm:"numeric(14,2) not null default 0" json:"currentPeriodFlat"`
	CurrentPeriodValley      decimal.Decimal     `xorm:"numeric(14,2) not null default 0" json:"currentPeriodValley"`
	AdjustOverall            decimal.Decimal     `xorm:"numeric(14,2) not null default 0" json:"adjustOverall"`
	AdjustCritical           decimal.Decimal     `xorm:"numeric(14,2) not null default 0" json:"adjustCritical"`
	AdjustPeek               decimal.Decimal     `xorm:"numeric(14,2) not null default 0" json:"adjustPeek"`
	AdjustFlat               decimal.Decimal     `xorm:"numeric(14,2) not null default 0" json:"adjustFlat"`
	AdjustValley             decimal.Decimal     `xorm:"numeric(14,2) not null default 0" json:"adjustValley"`
	Overall                  decimal.NullDecimal `xorm:"numeric(14,2)" json:"overall"`
	OverallFee               decimal.NullDecimal `xorm:"numeric(14,2)" json:"overallFee"`
	Critical                 decimal.NullDecimal `xorm:"numeric(14,2)" json:"critical"`
	CriticalFee              decimal.NullDecimal `xorm:"numeric(18,8)" json:"criticalFee"`
	Peek                     decimal.NullDecimal `xorm:"numeric(14,2)" json:"peek"`
	PeekFee                  decimal.NullDecimal `xorm:"numeric(18,8)" json:"peekFee"`
	Flat                     decimal.NullDecimal `xorm:"numeric(14,2)" json:"flat"`
	FlatFee                  decimal.NullDecimal `xorm:"numeric(18,8)" json:"flatFee"`
	Valley                   decimal.NullDecimal `xorm:"numeric(14,2)" json:"valley"`
	ValleyFee                decimal.NullDecimal `xorm:"numeric(18,8)" json:"valleyFee"`
	BasicFeeDiluted          decimal.NullDecimal `xorm:"numeric(18,8)" json:"basicFeeDiluted"`
	AdjustFeeDiluted         decimal.NullDecimal `xorm:"numeric(18,8)" json:"adjustFeeDiluted"`
	LossDiluted              decimal.NullDecimal `xorm:"numeric(18,8)" json:"lossDiluted"`
	LossFeeDiluted           decimal.NullDecimal `xorm:"numeric(18,8)" json:"lossFeeDiluted"`
	MaintenanceFeeDiluted    decimal.NullDecimal `xorm:"numeric(18,8)" json:"maintenanceFeeDiluted"`
	PublicConsumptionDiluted decimal.NullDecimal `xorm:"numeric(18,8)" json:"publicConsumptionDiluted"`
	FinalCharge              decimal.NullDecimal `xorm:"numeric(14,2)" json:"finalCharge"`
}

func (EndUserDetail) TableName() string {
	return "end_user_detail"
}
